# Written by Il-Chul Yoon <iyoon@cs.umd.edu>
# This file is adopted from Skoll project
#
package PerlDB;

use DBI;
use strict;

my $dbh = "";

sub new(){
    my $proto = shift;
    my $class = ref ($proto) || $proto;
    my $self = {};

    $dbh = &db_init();

    bless ($self, $class);

    return $self;
}


sub db_init {
    my $driver = "mysql";

    my $dbhost = "$ENV{DB_SERVER}";
    my $dbport = "$ENV{DB_PORT}";
    my $dbname = "$ENV{DB_NAME}";
    my $dbuser = "$ENV{DB_USER}";
    my $passwd = "$ENV{DB_PASSWD}";

    my $dsn = "DBI:$driver:database=$dbname;host=$dbhost;port=$dbport";
    return (DBI->connect($dsn, $dbuser, $passwd));
}

sub db_end {
    $dbh->disconnect();
}

#
# Use for selecting single column
#
sub select {
    my $self = shift;
    my $query = shift;

    my $sth = $dbh->prepare($query) or die "prepare error: ".$dbh->err;
    $sth->execute or die "execute error: ".$dbh->err;

    #initialize array and index
    my $i = 0;
    my @something = ();

    while(my $row = $sth->fetchrow) {
        $something[$i++] = $row;
    }

    $sth->finish;
   
    if($i > 0){
       return \@something;
    }
    else{
       return undef;
    }
}

sub multcol_select {
    my $self = shift;
    my $query = shift;

    my @something = ();

    my $sth = $dbh->prepare($query) or die "prepare error: ".$dbh->err;
    $sth->execute or die "execute error: ".$dbh->err;

    my $i = 0;
    while(my (@row) = $sth->fetchrow_array) {
        $something[$i++] = \@row;
    }

    if($i > 0){
       return \@something;
    }
    else{
       return undef;
    }
}

sub executequery {
    my $self = shift;
    my $query = shift;

    my $sth = $dbh->prepare($query) or return $dbh->err;

    $sth->execute() or return $dbh->err;

    return "Query Succeed!";
}

sub count {
    my $self = shift;
    my $table = shift;
    my $where = shift;

    my $query = undef;

    if (length($where) > 0){
        $query = "select count(*) from $table where $where" ;
    }
    else{
        $query = "select count(*) from $table" ;
    }

    my $sth = $dbh->prepare($query) or return $dbh->err;
    $sth->execute() or return $dbh->err;

    return $sth->fetchrow;
}



######################## Above... modified by Il-Chul Yoon ###############





sub deletetable {
    my $self = shift;
    my $table = shift;
    my $query = "delete from $table";
    my $exec = $dbh->prepare($query);
    $exec->execute();
}




1;
