#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_rc_register;

use PerlDB;
use utilfunc;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;
        
    print "<center>".$cgi->h1('Type Resource Information')."</center>";

    print $cgi->h3('Resource Detail');

    #&utilfunc::print_params($cgi);

    my $rctype = $cgi->param('rctype');

    if($rctype eq "cluster"){
        &regCluster($cgi, $rctype);
    }
    elsif($rctype eq "node"){
        &regNode($cgi, $rctype);
    }
    elsif($rctype eq "manager"){
        &regManager($cgi, $rctype);
    }
    
}

sub regCluster {
    my ($cgi, $rctype) = @_;

    print $cgi->start_form(-name=>'newrctable',
                           -onsubmit=>"return validate_newrc(this)");

    print $cgi->hidden(-name=>'rctype', -default=>$rctype);
    print $cgi->hidden(-name=>'mode', -default=>"newrcdetail");

    print $cgi->start_table({-border => 1});

    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::printEmptyTextField($cgi, "ClusterName", "clstname", 50, 80, "desc_cluster");

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_sched.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_sched.html')"},
                           "Scheduler"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'scheduler', 
                                    -values=>['SSH', 'PBS', 'LSF', 'LoadLeveler'],
                                    -default=>'SSH'));
    print $cgi->end_Tr();

    &utilfunc::printEmptyTextField($cgi, "Number of Nodes", "nNode", 50, 80, "desc_nNode");
    &utilfunc::printEmptyTextField($cgi, "Manager", "head", 50, 80, "desc_clusterhead");
    &utilfunc::printEmptyTextField($cgi, "Manager IP", "headip", 50, 80, "desc_headip");

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Register Resource', -onClick=>"to_rcsave(newrctable)");
    print $cgi->end_form;
}

sub regNode {
    my ($cgi, $rctype) = @_;

    print $cgi->start_form(-name=>'newrctable',
                           -onsubmit=>"return validate_newrc(this)");

    print $cgi->hidden(-name=>'rctype', -default=>$rctype);
    print $cgi->hidden(-name=>'mode', -default=>"newrcdetail");

    print $cgi->start_table({-border => 1});

    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::printEmptyTextField($cgi, "NodeName", "nodename", 50, 80, "desc_node");
    &utilfunc::printEmptyTextField($cgi, "NodeDomain", "domain", 50, 80, "desc_domain");
    &utilfunc::printEmptyTextField($cgi, "NodeIP", "nodeip", 50, 80, "desc_headip");

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Register Resource', -onClick=>"to_rcsave(newrctable)");
    print $cgi->end_form;
}

sub regManager {
    my ($cgi, $rctype) = @_;

    print $cgi->start_form(-name=>'newrctable',
                           -onsubmit=>"return validate_newrc(this)");

    print $cgi->hidden(-name=>'rctype', -default=>$rctype);
    print $cgi->hidden(-name=>'mode', -default=>"newrcdetail");

    print $cgi->start_table({-border => 1});

    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::printEmptyTextField($cgi, "Manager FullName", "head", 50, 80, "desc_mgrfullname");
    &utilfunc::printEmptyTextField($cgi, "Manager IP", "headip", 50, 80, "desc_headip");

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Register Resource', -onClick=>"to_rcsave(newrctable)");
    print $cgi->end_form;
}

1;
