#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_rcdetail;

use PerlDB;
use utilfunc;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;
        
    print "<center>".$cgi->h1('Resource Modification')."</center>";

    print $cgi->h3('Edit Resource');

    #&utilfunc::print_params($cgi);

    my $rctype = $cgi->param('rctype');
    my $id = -1;
    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+.choice\.(\d+)/){
            $id = $1;        
        }
    }
    
    if($rctype eq "cluster"){
        &showCluster($cgi, $id);
    }
    elsif($rctype eq "node"){
        &showNode($cgi, $id);
    }
    elsif($rctype eq "manager"){
        &showManager($cgi, $id);
    }
}


sub showCluster {
    my ($cgi, $clusterid) = @_;

    # Query to selected database    	
    my $perldb = new PerlDB();
    my $query = "SELECT cluster_id, clst_name, scheduler, nNode, available, 
                        mgr_host, mgr_hostip, resource.rc_id, rcmgr.mgr_id
                 FROM resource, rcmgr, cluster 
                 WHERE cluster.cluster_id=$clusterid and resource.rc_id=cluster.rc_id and 
                       rcmgr.mgr_id=resource.mgr_id";
    my @rcarray = @{$perldb->multcol_select($query)};
    $perldb->db_end ;

    # Show resources in Form
    print $cgi->start_form(-name=>'rctable',
                           -action=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/cgi-bin/HPCALE_REPMAN/rc_commit.cgi",
                           -onsubmit=>"return validate_rcdetail(this)");

    print $cgi->hidden(-name=>'rctype', -default=>$cgi->param('rctype'));
    print $cgi->hidden(-name=>'clusterid', -default=>$rcarray[0]->[0]);
    print $cgi->hidden(-name=>'rcid', -default=>$rcarray[0]->[7]);
    print $cgi->hidden(-name=>'mgrid', -default=>$rcarray[0]->[8]);

    print $cgi->start_table({-border => 1});
    
    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::showTextFieldWithValue ($cgi, 'cluster', 'ClusterName', 'clstname', $rcarray[0]->[1]);

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_sched.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_sched.html')"},
                           "Scheduler"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'scheduler', 
                                    -values=>['SSH', 'PBS', 'LSF', 'LoadLeveler'],
                                    -default=>$rcarray[0]->[2]));
    print $cgi->end_Tr();
    
    
    &utilfunc::showTextFieldWithValue ($cgi, 'nNode', 'Number of Nodes', 'nNode', $rcarray[0]->[3]);
    # Omit $rcarray[0]->[4] : available number of nodes
    &utilfunc::showTextFieldWithValue ($cgi, 'clusterhead', 'Manager', 'head', $rcarray[0]->[5]);
    &utilfunc::showTextFieldWithValue ($cgi, 'headip', 'Manager IP', 'headip', $rcarray[0]->[6]);

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Commit Modifications', -onClick=>"to_rccommit(rctable)");
    print $cgi->end_form;
}

sub showNode {
    my ($cgi, $nodeid) = @_;

    # Query to selected database    	
    my $perldb = new PerlDB();
    my $query = "SELECT node_id, node_name, domain, mgr_hostip, resource.rc_id, rcmgr.mgr_id
                 FROM resource, node, rcmgr
                 WHERE node.node_id=$nodeid and resource.rc_id=node.rc_id and 
                       rcmgr.mgr_id=resource.mgr_id";
    my @rcarray = @{$perldb->multcol_select($query)};
    $perldb->db_end ;

    # Show resources in Form
    print $cgi->start_form(-name=>'rctable',
                           -action=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/cgi-bin/HPCALE_REPMAN/rc_commit.cgi",
                           -onsubmit=>"return validate_rcdetail_node(this)");

    print $cgi->hidden(-name=>'rctype', -default=>$cgi->param('rctype'));
    print $cgi->hidden(-name=>'nodeid', -default=>$rcarray[0]->[0]);
    print $cgi->hidden(-name=>'rcid', -default=>$rcarray[0]->[4]);
    print $cgi->hidden(-name=>'mgrid', -default=>$rcarray[0]->[5]);

    print $cgi->start_table({-border => 1});
    
    print $cgi->start_Tr({-align=>'center', -valign=>'middle'});
    print $cgi->td("Element");
    print $cgi->td("Value");
    print $cgi->end_Tr;

    &utilfunc::showTextFieldWithValue ($cgi, 'node', 'NodeName', 'nodename', $rcarray[0]->[1]);
    &utilfunc::showTextFieldWithValue ($cgi, 'domain', 'Domain', 'domain', $rcarray[0]->[2]);
    &utilfunc::showTextFieldWithValue ($cgi, 'headip', 'IP', 'headip', $rcarray[0]->[3]);

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Commit Modifications', -onClick=>"to_rccommit_node(rctable)");
    print $cgi->end_form;
}

sub showManager {
    my ($cgi, $mgrid) = @_;

    # Query to selected database    	
    my $perldb = new PerlDB();
    my $query = "SELECT mgr_id, mgr_host, mgr_hostip
                 FROM rcmgr
                 WHERE mgr_id=$mgrid";
    my @rcarray = @{$perldb->multcol_select($query)};
    $perldb->db_end ;

    # Show resources in Form
    print $cgi->start_form(-name=>'rctable',
                           -action=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/cgi-bin/HPCALE_REPMAN/rc_commit.cgi",
                           -onsubmit=>"return validate_rcdetail_manager(this)");

    print $cgi->hidden(-name=>'rctype', -default=>$cgi->param('rctype'));
    print $cgi->hidden(-name=>'mgrid', -default=>$rcarray[0]->[0]);

    print $cgi->start_table({-border => 1});
    
    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::showTextFieldWithValue ($cgi, 'mgrfullname', 'Manager FullName', 'head', $rcarray[0]->[1]);
    &utilfunc::showTextFieldWithValue ($cgi, 'headip', 'Manager IP', 'headip', $rcarray[0]->[2]);

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Commit Modifications', -onClick=>"to_rccommit_manager(rctable)");
    print $cgi->end_form;
}

1;
