#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_sw;

use PerlDB;
use utilfunc;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
   my $self = shift;
   my $cgi = shift;
        
   print "<center>".$cgi->h1('Search Result')."</center>";

   print $cgi->h3('Select Software (if you want to modify)');

   #&utilfunc::print_params($cgi);

	# retrieve selectively from database using SQL pattern matching.
	# modify the regular expression mark to MySQL pattern matching style.
   my $swname = $cgi->param('swname');

   if(length(&utilfunc::trimwhitespace($swname)) == 0){
      print "Software name is necessary";
      return ;
   }

	$swname =~ s/\*/%/g;
	$swname =~ s/\?/_/g;

   &showSoftware($cgi, $swname);
}

sub showSoftware {
    my ($cgi, $swname) = @_;

    # Query to selected database    	
    my $perldb = new PerlDB();
    my $query = "SELECT id, compID, type, descfile, rcname
                 FROM component, resource
                 WHERE compID LIKE '$swname' and component.rc_id=resource.rc_id";
    my $res_ref = $perldb->multcol_select($query);
    $perldb->db_end ;

    if(not defined $res_ref){
       print "No such component is found.";
       return -1;
    }
    
    my @rcarray = @{$res_ref};

    # Show resources in Form
    print $cgi->start_form(-name=>'swtable',
                           -action=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/cgi-bin/HPCALE_REPMAN/sw_detail.cgi",
                           -onsubmit=>"return validate_onlyone_sw_checked(this)");

    print $cgi->start_table({-border => 1});
    print $cgi->start_Tr({-align=>'center', -valign=>'middle'});
    print $cgi->td("Select");
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_name.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_name.html')"},
                           "SoftwareName"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_type.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_type.html')"},
                           "Type"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_rcname.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_rcname.html')"},
                           "Resource"));
    print $cgi->end_Tr;

    foreach(@rcarray){
        print $cgi->start_Tr({-align=>'center', -valign=>'middle'});

        my $identifier = "$_->[0]";
        print $cgi->td($cgi->checkbox(-name=>"sw.choice.$identifier",
                                      -checked=>0,
                                      -value=>1,
                                      -label=>'')); # selection checkbox
                
        my $linkname = "$_->[1].html";
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/swdesc/$linkname",
                                -onClick=>"return popup_swinfo('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/swdesc/$linkname')"},
                                "$_->[1]")); # compID

        print $cgi->td($_->[2]);
        print $cgi->td($_->[4]);
        
        $cgi->end_Tr();
    }

    print $cgi->end_table;
    print "<br>";
    print $cgi->submit(-value=>'Modify Selected Software', -onClick=>"to_swdetail(swtable)");
    print $cgi->end_form;
}


1;
