#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_sw_register;

use PerlDB;
use utilfunc;
use Data::Dumper;

use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory

    bless($self, $classname);       # Mark it of the right type
    
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;
        
    print "<center>".$cgi->h1('Edit Software Detail')."</center>";

    print $cgi->h3('Edit Software');

    #&utilfunc::print_params($cgi);
    &showSoftware($cgi);
}

sub showSoftware {
    my $cgi = shift;

    print $cgi->start_form(-name=>'newswtable',
                           -onsubmit=>"return validate_swdetail(this)");

    print $cgi->hidden(-name=>'mode', -default=>"newswdetail");
    print $cgi->hidden(-name=>"rcid", -default=>);    
    
    print $cgi->start_table({-border => 1});
    
    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::showTextFieldWithValue ($cgi, 'name', 'SoftwareName', 'compid', 'testcomp1');
    &utilfunc::showTextFieldWithValue ($cgi, 'impportlist', 'Import PortList', 'imdataportlist', 'test1,test2');
    &utilfunc::showTextFieldWithValue ($cgi, 'expportlist', 'Export PortList', 'exdataportlist', 'test3,test4');
    &utilfunc::showTextFieldWithValue ($cgi, 'path', 'Path', 'path', '/');
    &utilfunc::showTextFieldWithValue ($cgi, 'file', 'File', 'file', 'test');
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_type.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_type.html')"},
                           "Type"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'type', 
                                    -values=>['MPI-executable', 'PVM-executable', 'Executable', 'OpenMP-executable']));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/APACHE/desc/desc_parallel.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_parallel.html')"},
                           "Parallel"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'parallel', 
                                    -values=>['0','1']));
    print $cgi->end_Tr();


    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_runtime.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_runtime.html')"},
                           "Runtime Environment"));
    print $cgi->td({-align=>'left'}, $cgi->scrolling_list(-name=>'runtimeenv',
                                                     -size=>4,
                                                     -values=>['','PVM','InterComm'],
                                                     -multiple=>'true'));
    print $cgi->end_Tr();

    &utilfunc::showTextFieldWithValue ($cgi, 'launchprog', 'Launch Program', 'launchprog', '');
    &utilfunc::showTextFieldWithValue ($cgi, 'launcharg', 'Launch Argument', 'launcharg', '');
    &utilfunc::showTextFieldWithValue ($cgi, 'rcname', 'Resource', 'rcname', 'coyote');
    &utilfunc::showTextFieldWithValue ($cgi, 'mgrfullname', 'Manager FullName', 'head', 'coyote.cs.umd.edu');

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_descfile.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_descfile.html')"},
                           "DescriptionFile"));
    print $cgi->td({-align=>'left'}, $cgi->filefield(-name=>'descfile',
                                                     -size=>50,
                                                     -maxlength=>255));
    print $cgi->end_Tr();

    print $cgi->end_table();
    print "<br>";
    
    print $cgi->submit(-value=>'Register Software', -onClick=>"to_newswsave(newswtable)");
    print $cgi->end_form;
	print $cgi->hr;
}

1;
