#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_swdetail;

use PerlDB;
use utilfunc;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;
        
    print "<center>".$cgi->h1('Software Modification')."</center>";

    print $cgi->h3('Edit Software');

    #&utilfunc::print_params($cgi);

    my $id = -1;
    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+.choice\.(\d+)/){
            $id = $1;        
        }
    }
    
    &showSoftware($cgi, $id);
}

sub showSoftware {
    my ($cgi, $swid) = @_;

    my $perldb = new PerlDB();
    my $query = "SELECT id, compID, component.rc_id, path, file, type, parallel, 
                        launchprog, launcharg, descfile, rcname, resource.mgr_id
                 FROM component, resource
                 WHERE id=$swid and component.rc_id=resource.rc_id";

    my $comp = $perldb->multcol_select($query)->[0];

    print $cgi->start_form(-name=>'swtable',
                           -action=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/cgi-bin/HPCALE_REPMAN/sw_commit.cgi",
                           -onsubmit=>"return validate_swdetail(this)");

    print $cgi->hidden(-name=>"id", -default=>$comp->[0]);    
    print $cgi->hidden(-name=>"rcid", -default=>$comp->[2]);    
    print $cgi->hidden(-name=>'mode', -default=>"swmodify");
    
    print $cgi->start_table({-border => 1});
    
    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::showTextFieldWithValue ($cgi, 'name', 'SoftwareName', 'compid', $comp->[1]);
   
    &show_importport($cgi, $swid, $perldb);
    &show_exportport($cgi, $swid, $perldb);

    &utilfunc::showTextFieldWithValue ($cgi, 'path', 'Path', 'path', $comp->[3]);
    &utilfunc::showTextFieldWithValue ($cgi, 'file', 'File', 'file', $comp->[4]);
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_type.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_type.html')"},
                           "Type"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'type', 
                                    -values=>['MPI-executable', 'PVM-executable', 'Executable', 'OpenMP-executable'],
                                    -default=>$comp->[5]));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_parallel.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_parallel.html')"},
                           "Parallel"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'parallel', 
                                    -values=>['0','1'],
                                    -default=>$comp->[6]));
    print $cgi->end_Tr();


    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_runtime.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_runtime.html')"},
                           "Runtime Environment"));

    &show_runtimes($cgi,$swid,$perldb);  
    print $cgi->end_Tr();

    &utilfunc::showTextFieldWithValue ($cgi, 'launchprog', 'Launch Program', 'launchprog', $comp->[7]);
    &utilfunc::showTextFieldWithValue ($cgi, 'launcharg', 'Launch Argument', 'launcharg', $comp->[8]);
    &utilfunc::showTextFieldWithValue ($cgi, 'rcname', 'Resource', 'rcname', $comp->[10]);

    $query = "SELECT mgr_host FROM rcmgr WHERE mgr_id=$comp->[11]";
    my $mgrhost = $perldb->select($query)->[0];
    print STDERR $mgrhost;
    &utilfunc::showTextFieldWithValue ($cgi, 'mgrfullname', 'Manager FullName', 'head', $mgrhost);

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_descfile.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_descfile.html')"},
                           "DescriptionFile"));
    print $cgi->td({-align=>'left'}, $cgi->filefield(-name=>'descfile',
                                                     -size=>50,
                                                     -maxlength=>255));
    print $cgi->end_Tr();

    print $cgi->end_table();
    print "<br>";
    
    print $cgi->submit(-value=>'Commit Modifications', -onClick=>"to_swcommit(swtable)");
    print $cgi->end_form;
	print $cgi->hr;
    
    $perldb->db_end ;
}

sub show_importport 
{
   my ($cgi,$swid,$perldb) = @_;

   my $query = "SELECT port_name FROM dataport WHERE component_id = $swid and port_type = 'import'";
   my $ref = $perldb->select($query);
   my $str = '';

   if(not defined $ref){
      $str = "";
   }
   else{
      my @portarr = @{$ref};
      $str = join ',', @portarr;
   }

   &utilfunc::showTextFieldWithValue ($cgi, 'impportlist', 'Import PortList', 'imdataportlist', $str);
}

sub show_exportport 
{
   my ($cgi,$swid,$perldb) = @_;

   my $query = "SELECT port_name FROM dataport WHERE component_id = $swid and port_type = 'export'";
   my $ref = $perldb->select($query);
   my $str = '';

   if(not defined $ref){
      $str = "";
   }
   else{
      my @portarr = @{$ref};
      $str = join ',', @portarr;
   }

    &utilfunc::showTextFieldWithValue ($cgi, 'expportlist', 'Export PortList', 'exdataportlist', $str);
}

sub show_runtimes {
   my ($cgi,$swid,$perldb) = @_;

   my $query = "SELECT req_name FROM runtimereq WHERE component_id = $swid";
   my $ref = $perldb->select($query);

   my @supported = qw/ PVM InterComm /;

   if(not defined $ref){
      print $cgi->td({-align=>'left'}, 
            $cgi->scrolling_list(-name=>'runtimeenv',
                                 -size=>3,
                                 -values=> \@supported,
                                 -multiple=>'true'));
   }
   else{
      # build default string for HTML
      my @defaults = @{$ref}; 

      print $cgi->td({-align=>'left'}, 
            $cgi->scrolling_list(-name=>'runtimeenv',
                                 -size=>3,
                                 -values=> \@supported,
                                 -default=> \@defaults,
                                 -multiple=>'true'));
   }
}

1;
