#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package utilfunc;

use PerlDB;
use Data::Dumper;
use strict;

sub printEmptyRow {
    my ($cgi, $asis, $title, $field, $desc) = @_;

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});

    if(length($desc) > 0 ){
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html')"},
                               "$title"));
        if($asis == 0){                               
            print $cgi->td("");
        }
        else{
            print $cgi->td($field);
        }
    }
    else{
        print $cgi->td($title);
        print $cgi->td($field);
    }
    
    print $cgi->end_Tr();
}

sub printSimpleRow {
    my ($cgi, $data, $asis, $title, $field, $desc) = @_;

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});

    if(length($desc) > 0 ){
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html')"},
                               "$title"));
        if($asis == 0){                               
            print $cgi->td($data->{$field});
        }
        else{
            print $cgi->td($field);
        }
    }
    else{
        print $cgi->td($title);
        print $cgi->td($field);
    }
    
    print $cgi->end_Tr();
}

sub printEmptyTextField {
   my ($cgi, $title, $field, $size, $maxlen, $desc) = @_;

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});

    if(length($desc) > 0 ){
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html')"},
                               "$title"));

        print $cgi->td($cgi->textfield( -name=>$field,
                                        -value=>"",
                                        -size=>$size,
                                        -maxlength=>$maxlen));
    }
    else{
        print $cgi->td($title);
        print $cgi->td($field);
    }
    
    print $cgi->end_Tr();
}


sub printSimpleTextField {
   my ($cgi, $data, $title, $field, $size, $maxlen, $desc) = @_;

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});

    if(length($desc) > 0 ){
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/$desc.html')"},
                               "$title"));

        my $value = $data->{$field};

        # 'suppressEmpty' option during XMLin function call, is used to set the 
        # empty value of elements as empty string.
        if($value eq "" || $value eq ''){
            $value = "";
        }

        print $cgi->td($cgi->textfield( -name=>$field,
                                        -value=>$value,
                                        -size=>$size,
                                        -maxlength=>$maxlen));
    }
    else{
        print $cgi->td($title);
        print $cgi->td($field);
    }
    
    print $cgi->end_Tr();
}

sub showTextFieldWithValue {
    my ($cgi, $descname, $name, $cginame, $value) = @_;
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_$descname.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/desc/desc_$descname.html')"},
                           $name));
    print $cgi->td($cgi->textfield( -name=>$cginame,
                                    -value=>$value,
                                    -size=>50,
                                    -maxlength=>80));
    print $cgi->end_Tr();
}


# Remove whitespace from the start and end of the string
sub trimwhitespace($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}

#
# Save new software or update software information 
#
sub saveSoftware {
    my $cgi = shift;

    my $swid = $cgi->param('id');
    my $rcid = $cgi->param('rcid');
    my $compid = $cgi->param('compid');
    my $path = $cgi->param('path');
    my $file = $cgi->param('file');
    my $type = $cgi->param('type');
    my $parallel = $cgi->param('parallel');
    my $launchprog = $cgi->param('launchprog');
    my $launcharg = $cgi->param('launcharg');
    my $rcname = $cgi->param('rcname');
    my $mgrhead = $cgi->param('head');

    my $impportlist = $cgi->param('imdataportlist');
    my $expportlist = $cgi->param('exdataportlist');
    my @runtimeenv = $cgi->param('runtimeenv');
    
    my $perldb = new PerlDB();

    # check manager first
    my $query = "SELECT rcname, mgr_id, rctype_id, rc_id FROM resource 
                 WHERE rcname='$rcname'";
    my $res_ref = $perldb->multcol_select($query);
    if(not defined $res_ref){
        print "<br>Invalid resource name<br>";
        $perldb->db_end ();
        return -1;
    }
    my @queryresult = @{$res_ref};

    my $matchIdx = -1;    
    foreach(@queryresult){
        my $rcname_indb = $_->[0];
        my $mgrid_indb = $_->[1];
        my $rctypeid_indb = $_->[2];
        my $rcid_indb = $_->[3];
   
        # check manager host
        $query = "SELECT mgr_host FROM rcmgr WHERE mgr_id='$mgrid_indb'";
        my $mgrhost_indb_ref = $perldb->select($query);
        if(! defined $mgrhost_indb_ref){
            print STDERR "Invalid Manager Host ID";
            print "<br>Inconsistent database status.<br>";
            $perldb->db_end ();
            return -1;
        }
        my $mgrhost_indb = $perldb->select($query)->[0];

        if($mgrhead eq $mgrhost_indb){
            $matchIdx = $rcid_indb;
        }
    }
    
    if($matchIdx == -1){
        print "<br>Manager host does not match with the given resource name.<br>";
        $perldb->db_end ();
        return -1;
    }
    
    if(! defined $cgi->param('mode')){
        print "<br>Error in saving software information<br>";
        $perldb->db_end();
        return -1;
    }
   
    # check duplicate component
    $query = "SELECT id FROM component WHERE compID='$compid' and rc_id='$matchIdx' ";
    my $id_indb_ref = $perldb->select($query);
    
    if(defined $id_indb_ref){
        if($cgi->param('mode') eq "savenewsw"){
            print "<br>Unable to register. Duplicate Software on the specified resource<br>";
            $perldb->db_end ();
            return -1;
        }
    }
    
    # save description file
    my $saveresult = &save_desc_file ($cgi); 
    my $descfilename = "";
    if($saveresult == 1){
        $descfilename = "$compid.html";
    }
    
    if($cgi->param('mode') eq "savenewsw"){
        $query = "INSERT INTO component
                  SET compID='$compid', rc_id=$matchIdx ,path='$path',file='$file',
                      type='$type', parallel='$parallel', 
                      launchprog='$launchprog', launcharg='$launcharg',
                      descfile='$descfilename'";
        $perldb->executequery($query);
    }
    elsif($cgi->param('mode') eq "swmodify"){
        $query = "UPDATE component
                  SET compID='$compid', rc_id=$matchIdx ,path='$path',file='$file',
                      type='$type', parallel='$parallel', 
                      launchprog='$launchprog', launcharg='$launcharg',
                      descfile='$descfilename' 
                  WHERE id=$swid";
        $perldb->executequery($query);
    }

    $query = "SELECT id
              FROM component
              WHERE compID='$compid' and rc_id=$matchIdx";
    $swid = $perldb->select($query)->[0];              

    # first, delete port information before inserting again.
    $query = "DELETE FROM dataport
              WHERE component_id=$swid";
    $perldb->executequery($query);                      
    
    # register import data port list    
    my @impports = split /,/, $impportlist;
    foreach(@impports){
        my $curport = &trimwhitespace($_);
        
        $query = "INSERT INTO dataport
                  SET component_id='$swid', port_name='$curport', port_type='import', 
                      port_desc=''";
        $perldb->executequery($query);                      
    }
    
    my @expports = split /,/, $expportlist;
    foreach(@expports){
        my $curport = &trimwhitespace($_);
        
        $query = "INSERT INTO dataport
                  SET component_id='$swid', port_name='$curport', port_type='export'";
        $perldb->executequery($query);                      
    }

    # first, delete runtime requirements before inserting again.
    $query = "DELETE FROM runtimereq
              WHERE component_id=$swid";
    $perldb->executequery($query);                      

    foreach(@runtimeenv){
        next if(length($_) == 0);
        $query = "INSERT INTO runtimereq
                  SET component_id='$swid', req_name='$_'";
        $perldb->executequery($query);                      
    }

    $perldb->db_end ();
    return 1;
}

#
# Store software description file into the server
#
sub save_desc_file {
    my $cgi = shift;

    my $compid = $cgi->param('compid');
    my $fp = $cgi->param('descfile');
    
    if(-e "$ENV{HTDOCS_HOME}/HPCALE_REPMAN/swdesc/$compid.html"){
        unlink "$ENV{HTDOCS_HOME}/HPCALE_REPMAN/swdesc/$compid.html";
    }
    
    if(! defined $fp){
        return -1;
    }
    
    if(length($fp) == 0){
        return -1;
    }
    
    open OUT, "> $ENV{HTDOCS_HOME}/HPCALE_REPMAN/swdesc/$compid.html";
    while(<$fp>){
        print OUT $_;
    }
    close OUT;
    
    return 1;
}

#
# Remove selected softwares from repository
#
sub removeSoftware {
    my $cgi = shift;
    
    my @sw_idlist = ();
    
    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+\.choice\.(\d+)/){
            push @sw_idlist, $1;
        }
    }
    
    my $perldb = new PerlDB();
    foreach(@sw_idlist){
        my $query = "SELECT id, compID, descfile FROM component WHERE id=$_";
        my $queryresult = $perldb->multcol_select($query)->[0];
        my $swid = $queryresult->[0];
        my $compid = $queryresult->[1];
        my $descfile = $queryresult->[2];

        # first, delete port information 
        $query = "DELETE FROM dataport
                  WHERE component_id=$swid";
        $perldb->executequery($query);                      
        
        # first, delete runtime requirements 
        $query = "DELETE FROM runtimereq
                  WHERE component_id=$swid";
        $perldb->executequery($query);                      

        # first, delete component
        $query = "DELETE FROM component
                  WHERE id=$swid";
        $perldb->executequery($query);                      

        if(defined $descfile &&length($descfile) > 0){
            if(-e "$ENV{HTDOCS_HOME}/HPCALE_REPMAN/swdesc/$descfile"){
                unlink "$ENV{HTDOCS_HOME}/HPCALE_REPMAN/swdesc/$descfile";
            }
        }       
    }
    $perldb->db_end ();
    
    return 1;
}

#
# Store new cluster information into repository
#
sub saveNewCluster {
    my $cgi = shift;

    my $perldb = new PerlDB();

    my $rctype_id = 1;
    my $clstname = $cgi->param('clstname');
    my $scheduler = $cgi->param('scheduler');
    my $nNode = $cgi->param('nNode');

    # find this mgr to modify resource table
    my $head = $cgi->param('head');
    my $headip = $cgi->param('headip');

    if(length($head)==0 or length($clstname)==0 or length($headip)==0 or length($nNode)==0){
       print "Insufficient input";
       $perldb->db_end();
       return -1;
    }

    # check manager first
    my $query = "SELECT mgr_id, mgr_hostip FROM rcmgr WHERE mgr_host='$head'";
    my $mgr_indb_ref = $perldb->multcol_select($query);
    if(not defined $mgr_indb_ref){ 
        print "Unregistered Manager (Register manager first)";
        $perldb->db_end ();
        return -1;
    }

    my $mgr_indb = $mgr_indb_ref->[0];
    my $mgr_id = $mgr_indb->[0];
    my $mgr_hostip = $mgr_indb->[1]; 
    if(not ($mgr_hostip eq $headip)){
        print "Resource Manager information is not valid. (check ip and host name)";
        $perldb->db_end ();
        return -1;
    }

    # check duplicate cluster 
    $query = "SELECT cluster_id
              FROM resource, cluster 
              WHERE clst_name='$clstname' and 
                    resource.rc_id = cluster.rc_id and resource.mgr_id=$mgr_id ";
    my $clusterid_indb_ref = $perldb->select($query); 

    if(defined $clusterid_indb_ref){
        print "Trying to register duplicate resource ...\n";
        $perldb->db_end ();
        return -1;
    }

    # insert to resource table first
    $query = "INSERT INTO resource
              SET mgr_id=$mgr_id, rctype_id = $rctype_id, rcname = '$clstname'";
    $perldb->executequery($query);

    # get rc_id 
    $query = "SELECT rc_id
              FROM resource
              WHERE mgr_id = $mgr_id and rctype_id = $rctype_id and rcname = '$clstname'";
    my $rcid_indb = $perldb->select($query)->[0];
    
    # insert to cluster table    
    $query = "INSERT INTO cluster
              SET clst_name='$clstname', scheduler='$scheduler', nNode=$nNode, available=$nNode, rc_id=$rcid_indb";
    $perldb->executequery($query);
                  
    $perldb->db_end ();

    return 1;
}


#
# Store new node information into repository
#
sub saveNewNode {
    my $cgi = shift;

    my $perldb = new PerlDB();

    my $rctype_id = 2;
    my $nodename = $cgi->param('nodename');
    my $domain = $cgi->param('domain');
    my $ip = $cgi->param('nodeip');

    if(length($nodename)==0 or length($domain)==0 or length($ip)==0){
       print "Insufficient input";
       $perldb->db_end();
       return -1;
    }

    # check duplicate node 
    my $query = "SELECT node_id
                 FROM node
                 WHERE node_name='$nodename' and domain='$domain'";
    my $node_indb_ref = $perldb->select($query);
    if(defined $node_indb_ref){
        print STDERR "Trying to register duplicate node...\n";
        $perldb->db_end ();
        return -1;
    }

    # check manager first
    $query = "SELECT mgr_id, mgr_hostip FROM rcmgr WHERE mgr_host='$nodename.$domain'";
    my $mgr_indb_ref = $perldb->multcol_select($query);
    my $mgr_id = undef;

    if(not defined $mgr_indb_ref){ 
        # insert to rcmgr table first
        $query = "INSERT INTO rcmgr
                  SET mgr_host='$nodename.$domain', mgr_hostip='$ip'";
        $perldb->executequery($query);

        # get the mgr_id
        $query = "SELECT mgr_id FROM rcmgr WHERE mgr_host='$nodename.$domain'";
        $mgr_id = $perldb->select($query)->[0];
    }
    else{
       my $mgr_indb = $mgr_indb_ref->[0];
       $mgr_id = $mgr_indb->[0];
       my $mgr_hostip = $mgr_indb->[1]; 
       if(not ($mgr_hostip eq $ip)){
           print "Resource information is not matched with manager information. (check ip and host name)";
           $perldb->db_end ();
           return -1;
       }
    }

    if(! defined $mgr_id){
        print "Unable to update resource manager information.";
        $perldb->db_end ();
        return -1;
    }

    # insert to resource table 
    $query = "INSERT INTO resource
              SET mgr_id=$mgr_id, rctype_id = $rctype_id, rcname = '$nodename'";
    $perldb->executequery($query);

    # get rc_id 
    $query = "SELECT rc_id
              FROM resource
              WHERE mgr_id = $mgr_id and rctype_id = $rctype_id and rcname = '$nodename'";
    my $rcid_indb = $perldb->select($query)->[0];
    
    # insert to node table    
    $query = "INSERT INTO node
              SET node_name='$nodename', domain='$domain', rc_id=$rcid_indb ";
    $perldb->executequery($query);
                  
    $perldb->db_end ();

    return 1;
}


#
# Store new resource manager information into repository
#
sub saveNewManager {
    my $cgi = shift;

    my $perldb = new PerlDB();

    my $mgrname = $cgi->param('head');
    my $ip = $cgi->param('headip');

    # check manager first
    my $query = "SELECT mgr_id FROM rcmgr WHERE mgr_host='$mgrname'";
    my $mgr_indb_ref = $perldb->select($query);

    if(defined $mgr_indb_ref){
        print "Duplicate Manager registration.\n";
        $perldb->db_end ();
        return -1;
    }    
    
    # insert to rcmgr table first
    $query = "INSERT INTO rcmgr
              SET mgr_host='$mgrname', mgr_hostip='$ip'";
    $perldb->executequery($query);
    $perldb->db_end ();
    
    return 1;
}    


#
# Update the cluster information in repository
#
sub saveCluster {
    my $cgi = shift;

    my $perldb = new PerlDB();

    my $clstname = $cgi->param('clstname');
    my $scheduler = $cgi->param('scheduler');
    my $nNode = $cgi->param('nNode');
    
    my $clusterid = $cgi->param('clusterid');
    my $rcid = $cgi->param('rcid');
    my $mgrid = $cgi->param('mgrid');

    # find this mgr to modify resource table
    my $head = $cgi->param('head');
    my $headip = $cgi->param('headip');

    # check the new manager info.
    my $query = "SELECT mgr_id, mgr_hostip FROM rcmgr WHERE mgr_host='$head'";
    my $mgr_indb_ref = $perldb->multcol_select($query);
    if(not defined $mgr_indb_ref){ 
        print "Unregistered Manager (Register manager first)";
        $perldb->db_end ();
        return -1;
    }

    my $mgr_indb = $mgr_indb_ref->[0];
    my $mgr_id = $mgr_indb->[0];
    my $mgr_hostip = $mgr_indb->[1]; 
    if(not ($mgr_hostip eq $headip)){
        print "Resource Manager information is not valid. (check ip and host name)";
        $perldb->db_end ();
        return -1;
    }

    # update cluster table    
    $query = "UPDATE cluster 
              SET clst_name='$clstname', scheduler='$scheduler', nNode='$nNode'
              WHERE cluster_id = $clusterid";
    $perldb->executequery($query);

    # update resource table
    $query = "UPDATE resource SET mgr_id='$mgr_id' WHERE rc_id = $rcid";
    $perldb->executequery($query);

    $perldb->db_end ();

    return 1;
}

#
# Update the node information in repository
#
sub saveNode {
    my $cgi = shift;

    my $perldb = new PerlDB();

    my $nodename = $cgi->param('nodename');
    my $domain = $cgi->param('domain');
    my $headip = $cgi->param('headip');
    
    my $nodeid = $cgi->param('nodeid');
    my $rcid = $cgi->param('rcid');
    my $mgrid = $cgi->param('mgrid');


    my $query = "SELECT mgr_id FROM rcmgr WHERE mgr_host='$nodename.$domain'";
    my $new_mgrid_ref = $perldb->select($query);

    if(defined $new_mgrid_ref){
        print "Same node already exist";
        $perldb->db_end ();
        return -1;
    }

    # update node table    
    $query = "UPDATE node 
              SET node_name='$nodename', domain='$domain'
              WHERE node_id = $nodeid";
    $perldb->executequery($query);

    # update rcmgr table
    $query = "UPDATE rcmgr 
              SET mgr_host='$nodename.$domain', mgr_hostip='$headip'
              WHERE mgr_id = $mgrid";
    $perldb->executequery($query);

    # update resource table
    $query = "UPDATE resource 
              SET rcname='$nodename'
              WHERE rc_id = $rcid";
    $perldb->executequery($query);

    $perldb->db_end ();

    return 1;
}


#
# Update the resource manager information in repository
#
sub saveManager {
    my $cgi = shift;

    my $perldb = new PerlDB();

    my $mgrid = $cgi->param('mgrid');    
    my $mgrname = $cgi->param('head');
    my $ip = $cgi->param('headip');

    # check manager first for the new mgr name
    my $query = "SELECT mgr_id FROM rcmgr WHERE mgr_host='$mgrname'";
    my $mgrid_ref = $perldb->select($query);

    if(defined $mgrid_ref){
        print "Same manager already exist";
        $perldb->db_end ();
        return -1;
    }

    $query = "SELECT rc_id FROM resource WHERE mgr_id = $mgrid and rctype_id = 2";
    my $link2node_ref = $perldb->select($query);
    if(defined $link2node_ref){
        print "A node is linked with this resource manager. Change the node information instead to keep database consistent.";
        $perldb->db_end ();
        return -1;
    }

    # update resource table
    $query = "UPDATE rcmgr 
              SET mgr_host='$mgrname', mgr_hostip='$ip'
              WHERE mgr_id = $mgrid";
    $perldb->executequery($query);

    $perldb->db_end ();

    return 1;
}


#
# Remove cluster information from repository
#
sub removeCluster {
    my $cgi = shift;
    
    my @cluster_idlist = ();
    
    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+\.choice\.(\d+)/){
            push @cluster_idlist, $1;
        }
    }
    
    my $perldb = new PerlDB();
    foreach(@cluster_idlist){
        my $query = "SELECT rc_id FROM cluster WHERE cluster_id=$_";
        my $rc_id = $perldb->select($query)->[0];

        $query = "DELETE FROM cluster WHERE cluster_id=$_";
        my $ret = $perldb->executequery($query);
        if($ret ne "Query Succeed!"){
            return -1;
        }
 
        $query = "DELETE FROM resource WHERE rc_id=$rc_id";
        $ret = $perldb->executequery($query);
        if($ret ne "Query Succeed!"){
            return -1;
        }

    }
    $perldb->db_end ();

    return 1;
}

#
# Remove node information from repository
#
sub removeNode {
    my $cgi = shift;

    my @node_idlist = ();

    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+\.choice\.(\d+)/){
            push @node_idlist, $1;
        }
    }
    
    my $perldb = new PerlDB();
    foreach(@node_idlist){
        my $query = "SELECT rc_id FROM node WHERE node_id=$_";
        my $rc_id = $perldb->select($query)->[0];
        
        $query = "DELETE FROM node WHERE node_id=$_";
        my $ret = $perldb->executequery($query);
        if($ret ne "Query Succeed!"){
            return -1;
        }

        $query = "DELETE FROM resource WHERE rc_id=$rc_id";
        $ret = $perldb->executequery($query);
        if($ret ne "Query Succeed!"){
            return -1;
        }
    }
    $perldb->db_end ();

    return 1;
}

#
# Remove resource manager information from repository
#
sub removeManager {
    my $cgi = shift;
    
    my @manager_idlist = ();

    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+\.choice\.(\d+)/){
            push @manager_idlist, $1;
        }
    }
    
    my $perldb = new PerlDB();
    foreach (@manager_idlist){
        my $query = "SELECT mgr_id
                     FROM node,resource
                     WHERE resource.rc_id=node.rc_id and rctype_id=2 and mgr_id=$_";
        my $exist_ref = $perldb->select($query);
        
        if(defined $exist_ref){
            print "There exists a node with manager.";
            $perldb->db_end ();
            return -1;
        }

        $query = "SELECT mgr_id
                  FROM cluster,resource
                  WHERE resource.rc_id=cluster.rc_id and rctype_id=1 and mgr_id=$_";
        $exist_ref = $perldb->select($query);
        
        if(defined $exist_ref){
            print "There exist clusters with manager";
            $perldb->db_end ();
            return -1;
        }

        $query = "DELETE FROM rcmgr WHERE mgr_id=$_";
        $perldb->executequery($query);
    }
    $perldb->db_end ();
    
    return 1;
}

1;

